# subviwer.pm v0.1
#
# Copyright (c) 2005 Joni Valtanen
# GNU General Public Licence v2
#
# Version information
#
# 0.01  -  051107, Joni Valtanen
#    * created

package Subtitle::Jacosub;

use 5.008004;
use strict;
use warnings;

require Exporter;

require Subtitle;

use AutoLoader qw(AUTOLOAD);

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use Subtitle::jacosub ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);

our $VERSION = '0.01';


# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.
sub IsWritable
  {
   return 1;
}

sub IsFormat
  {
    my ($input) = @_;
    if( ( $input eq "JACOSUB" ) || ( $input eq "jacosub" ) )
      {
	return 1;
      }
    return 0;
  }

sub IsThis
  {
    my ($input) = @_;

    my $isJaco=0;
    my @line_t1;
    my @line_t2;
    my @line_t3;
    my $i;
    my $j=1;
    my $test=0;
    my $time1=0;
    my $time2=0;
    my $text=0;
    my $line;

    open IFILE, "$input" or die("Couldn't open $input\n") ;

    for ($i=0; ( ($i<6) && ( $line = readline(IFILE)) ) ;$i++) {
      @line_t1 = split(/\n/,$line);
      @line_t1 = split(/\r/,$line_t1[0]);
      @line_t1 = split(/#/,$line_t1[0]);
      if($line_t1[0]) {
	@line_t2 = split(/ /,$line_t1[0]);
	if( $line_t2[2] eq "{~}") {
	    $test = 1;
	  }
	if( $line_t2[3]) {
	    $text = 1;
	  }
	if($line_t2[3]) {
	  @line_t3 = split(/:/,$line_t2[0]);
	  if( &Subtitle::IsNumeric($line_t3[0]) ) {
	      if( &Subtitle::IsNumeric($line_t3[1]) ) {
		  if( &Subtitle::IsDecimal($line_t3[2]) ) {
		      $time1=1;
		    }
		}
	    }
	  @line_t3 = split(/:/,$line_t2[1]);
	  if( &Subtitle::IsNumeric($line_t3[1]) ) {
	      if( &Subtitle::IsNumeric($line_t3[1]) ) {
		  if( &Subtitle::IsDecimal($line_t3[2]) ) {
		      $time2=1;
		    }
		}
	    }
	  }
	}
      }

    close IFILE;

    if($time1 && $time2 && $test && $text)
      {
	$isJaco = 1;
      }
    return $isJaco;
}

sub ReadFile()
  {
    my ($input,$fps) = @_;

    my $line;
    my $i=0;
    my $j=3;
    my $test;
    my @line_t1;
    my @line_t2;
    my @line_t3;
    my @line_t4;
    my @sub;

    open IFILE, "$input" or die("Couldn't open $input\n") ;

    # reads whole file line by line
    # and writes it to stdout
    while ($line =  readline(IFILE)) {
      @line_t1 = split(/\r/, $line);
      @line_t1 = split(/\n/, $line_t1[0]);
      @line_t1 = split(/#/, $line_t1[0]);
      if( $line_t1[0] ) {
	@line_t1 = split(/ /, $line_t1[0]);
      # drops negatives out ;)
      if ( $line_t1[0] && $line_t1[1] && $line_t1[2] && $line_t1[3] ) {
	$sub[$i]{start} = &Subtitle::ConvertTimeToFPS($line_t1[0], $fps );
	$sub[$i]{end} = &Subtitle::ConvertTimeToFPS($line_t1[1], $fps );
	$sub[$i]{starttime} = $line_t1[0]."0";
	$sub[$i]{endtime} = $line_t1[1]."0";
	$j=3; # join splitted spaces back
	while($line_t1[$j]){
	  $sub[$i]{subtitle} .= $line_t1[$j]." ";
	$j++;
	}
	$sub[$i]{subtitle} =~ s/\\n/|/g; # replace "\n"-string with '|'-char
	$i++;
      }
      }
    }
      #close everything
      close IFILE;
    return ($i, @sub);
  }

# in: file to write, number of subtitles, @subtitles in mode $subtitle[number]{start|end|subtitle}
sub WriteFile()
  {
    my ($output, $lines, @subtitles) = @_;
    my $oldout;
    my $line;
    my $test;
    my $i=0;
    my $starttime;
    my $endtime;
    my $subtitle;

    open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";
    open STDOUT, ">$output" or die("Couldn't open $output\n") ;

    # writes whole file line by line
    while ($i<$lines) {
      $starttime = substr( $subtitles[$i]{starttime} , 0, - 1); # removes last char
      $endtime = substr( $subtitles[$i]{endtime}, 0, - 1);
      $subtitle = $subtitles[$i]{subtitle};
      $subtitle =~ s/\|/\\n/g; # replace '|' '\n'-char

      $line = $starttime." ".$endtime." {~} ".$subtitle."\r\n";
      print "$line";
      $i++;
    }

    #close everything
    close STDOUT;
    open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";
  }

sub WriteFileFromTo()
  {
    my ($output, $from, $to, $shift, $fps, @subtitles) = @_;

    my $i=0;
    my $j=0;
    my $line="";
    my $oldout;
    my $endtime;
    my $starttime;
    my $subtitle;

  # Save subtitle file from frame to
  # from
  while ( $from > $subtitles[$i]{start} )
    {
      $i++;
    }

  $j=$i;

  while ( ( $to > $subtitles[$j]{start} ) )
	{
	  $j++;
	}

    open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";
    open STDOUT, ">$output" or die("Couldn't open $output\n") ;

    # writes whole file line by line
    while ( ($i <= $j) ) {
      $starttime = substr( &Subtitle::ConvertFPSToTime( ( $subtitles[$i]{start} + $shift), $fps ) , 0, - 1); # removes last char
      $endtime = substr( &Subtitle::ConvertFPSToTime( ( $subtitles[$i]{end} + $shift ), $fps ), 0, - 1);
      $subtitle = $subtitles[$i]{subtitle};
      $subtitle =~ s/\|/\\n/g; # replace '|' '\n'-char

      $line = $starttime." ".$endtime." {~} ".$subtitle."\r\n";
      print "$line";
      $i++;
    }

    #close everything
    close STDOUT;
    open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";

  }

1;
__END__

=head1 NAME

Subtitle::Jacosub - Perl extension for identifying, loading and saving JacoSub subtitles

=head1 SYNOPSIS

  use Subtitle::Jacosub;
  #load jacosub subtitle
   my $fps=25;
   my $filename="subtitle.jss";
   my ($lines, @sub) = &Subtitle::Jacosub::ReadFile($filename, $fps);
   for my $i (0...($lines-1))
   {
      print "start frame: @sub[$i]{start}\n";
      print "end frame: @sub[$i]{end}\n";
      print "start time: @sub[$i]{starttime}\n";
      print "end time: @sub[$i]{endtime}\n";
      print "subtitle: @sub[$i]{subtitle}\n";
   }

=head1 DESCRIPTION

Subtitle::Jacosub allows perl developer easily read and write JacoSub subtitles. Parsing is done by this extension.

=head2 EXPORT

None by default.



=head1 SEE ALSO

Perl(1)

Subtitle(3pm)
Subtitle::Microdvd(3pm)
Subtitle::Subviewer(3pm)

http://www.kapsi.fi/~jvaltane/subtitle/

=head1 AUTHOR

Joni Valtanen, E<lt>jvaltane@kapsi.fiE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2005 by Joni Valtanen

This library is free software; you can redistribute it and/or modify
it under the GNU General Public Licence version 2.

Read COPYING from the package for further information.

=cut
