# subviwer.pm v0.1
#
# Copyright (c) 2005 Joni Valtanen
# GNU General Public Licence v2
#
# Version information
#
# 0.01  -  051107, Joni Valtanen
#    * created
#
# 0.02  -  051116, Joni Valtanen
#    * added WriteFileFromTo -function

package Subtitle::Subviewer;

use 5.008004;
use strict;
use warnings;

require Exporter;

require Subtitle;

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use Subtitle ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);

our $VERSION = '0.02';


# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.
sub IsWritable
  {
   return 1;
}

sub IsFormat
  {
    my ($input) = @_;
    if( ( $input eq "SUBVIEWER" ) || ( $input eq "subviewer" ) )
      {
	return 1;
      }
    return 0;
  }

sub IsThis
  {
    my ($input) = @_;

    my $isSubviewer=0;
    my @line_t1;
    my @line_t2;
    my @line_t3;
    my $i;
    my $j=1;
    my $num=0;
    my $time=0;
    my $text=0;
    my $line;

    open IFILE, "$input" or die("Couldn't open $input\n") ;

    for ($i=0; ( ($i<4) && ( $line = readline(IFILE)) ) ;$i++) {
      @line_t1 = split(/\n/,$line);
      if($line_t1[0])
      {
      @line_t1 = split(/\r/,$line_t1[0]);
      if($line_t1[0])
      {
	@line_t2 = split(/ /,$line_t1[0]);
      if($line_t1[0])
      {
	if($j eq $line_t1[0])
	{
	  $num = 1;
	}
	elsif($line_t2[1] eq "-->")
	    {
	      $time=1;
	    }
	elsif( ( $line_t2[0] ne "" ) && ( $i > 1) )
	    {
	      $text=1;
	    }
      }
    }
    }
    }
    close IFILE;

    if($time && $num && $text)
      {
	$isSubviewer = 1;
      }
    return $isSubviewer;
  }

sub ReadFile
  {
    my ($input, $fps) = @_;

    my $line;
    my $i=0;
    my @line_t1;
    my @line_t2;
    my @line_t3;
    my @line_t4;
    my @sub;

    open IFILE, "$input" or die("Couldn't open $input\n") ;

    # reads whole file line by line
    # and writes it to stdout
    while($line =  readline(IFILE)) {
      @line_t1 = split(/\n/, $line);
      @line_t1 = split(/\r/, $line_t1[0]);
      if($line_t1[0])
	{
	  if( $line_t1[0] == ($i+1) ) {
	$line =  readline(IFILE);
	@line_t2 = split(/\r/, $line);
	@line_t2 = split(/\n/, $line_t2[0]);
	$line_t2[0]  =~ s/,/./g; # replace ,-char with .-char
	@line_t2 = split(/ /, $line_t2[0]);

	if( $line_t2[2] ) {
	    $sub[$i]{starttime} = $line_t2[0];
	    $sub[$i]{endtime} = $line_t2[2];
	    $sub[$i]{start} = &Subtitle::ConvertTimeToFPS( $line_t2[0], $fps );
	    $sub[$i]{end} = &Subtitle::ConvertTimeToFPS( $line_t2[2], $fps );
	    $sub[$i]{subtitle} = "";
	    do {
	      $line =  readline(IFILE);
	      @line_t1 = split(/\n/, $line);
	      if($line_t1[0]){
		  @line_t1 = split(/\r/, $line_t1[0]);
		  if ( $line_t1[0] ) {
		    if ( $line_t1[0] ne "") {
		      $sub[$i]{subtitle} .= $line_t1[0]."|";
		    }
	        }
	      }
	    }while( $line_t1[0] );
	    $sub[$i]{subtitle} = substr($sub[$i]{subtitle}, 0, - 1);
	    $i++;
	
	  }
      }
	}
    }
    #close everything
    close IFILE;

    return ($i, @sub);
  }

# in: file to write, number of subtitles, @subtitles in mode $subtitle[number]{start|end|starttime|endtime|subtitle}
#
# $lines are number of subtitles
#
sub WriteFile()
  {
    my ($output, $lines, @subtitles) = @_;
    my $oldout;
    my $line;
    my $test;
    my $i=0;
    my $ind=1;
    my $subtitle;
    open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";
    open STDOUT, ">$output" or die("Couldn't open $output\n") ;

    # writes whole file line by line
    while ($i<$lines) {
      $subtitle = $subtitles[$i]{subtitle};
      $subtitle =~ s/\|/\n/g; # replace '|' '\n'
      $ind = $i+1;
      $line = "$ind\n".$subtitles[$i]{starttime}." --> ".$subtitles[$i]{endtime}."\n".$subtitle."\r\n\n";
      print "$line";
      $i++;
    }

    #close everything
    close STDOUT;
    open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";
  }

sub WriteFileFromTo()
  {
    my ($output, $from, $to, $shift, $fps, @subtitles) = @_;

    my $i=0;
    my $j=0;
    my $line="";
    my $oldout;
    my $subtitle;
    my $starttime;
    my $endtime;
    my $ind=0;
  # Save subtitle file from frame to
  # from
  while ( $from > $subtitles[$i]{start} )
    {
      $i++;
    }

  $j=$i;

  while ( ( $to > $subtitles[$j]{start} ) )
	{
	  $j++;
	}

    open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";
    open STDOUT, ">$output" or die("Couldn't open $output\n") ;

    # writes whole file line by line
#    for(; $i<$j; $i++){
    while ( ($i <= $j) ) {
      $starttime = &Subtitle::ConvertFPSToTime( ( $subtitles[$i]{start} + $shift), $fps );
      $endtime = &Subtitle::ConvertFPSToTime( ( $subtitles[$i]{end} + $shift ), $fps );
      $subtitle = $subtitles[$i]{subtitle};
      $subtitle =~ s/\|/\n/g; # replace '|' '\n'
      $line = ++$ind."\n".$starttime." --> ".$endtime."\n".$subtitle."\r\n\n";
      print "$line";
      $i++;
#      $line = "{".int( $subtitles[$i]{start} + $shift)."}{".int( $subtitles[$i]{end} + $shift )."}".$subtitles[$i]{subtitle}."\r\n";
    }

    #close everything
    close STDOUT;
    open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";

  }

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

Subtitle::Subviewer - Perl extension for identifying, loading and saving SubViewer subtitles.

=head1 SYNOPSIS

  use Subtitle::Subviewer;
  #load Subviewer subtitle
   my $fps=25;
   my $filename="subtitle.srt";
   my ($lines, @sub) = &Subtitle::Subviewer::ReadFile($filename, $fps);
   for my $i (0...($lines-1))
   {
      print "start frame: @sub[$i]{start}\n";
      print "end frame: @sub[$i]{end}\n";
      print "start time: @sub[$i]{starttime}\n";
      print "end time: @sub[$i]{endtime}\n";
      print "subtitle: @sub[$i]{subtitle}\n";
   }

=head1 DESCRIPTION

Subtitle::Subviewer allows perl developer easily read and write Subviewer subtitles. Parsing is done by this extension.

=head2 EXPORT

None by default.



=head1 SEE ALSO

Perl(1)

Subtitle(3pm)
Subtitle::Microdvd(3pm)
Subtitle::Jacosub(3pm)

http://www.kapsi.fi/~jvaltane/subtitle/

=head1 AUTHOR

Joni Valtanen, E<lt>jvaltane@kapsi.fiE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2005 by Joni Valtanen

This library is free software; you can redistribute it and/or modify
it under the GNU General Public Licence version 2.

Read COPYING from the package for further information.

=cut
